// Source file: ../../sourcen/shell/io/Input.java

package io;

import java.util.LinkedList;
import java.util.ListIterator;
import knowledge.Concept;
import knowledge.T_Box;
import systemcontrol.*;

/**
   Die Klasse Input ist fuer alle Operationen bzgl. der Eingabe
   zustaendig, d.h. sie generiert die Eingabemaske, holt die Eingabedaten.
   Ausserdem reagiert sie auf Aktionen wie Abbruch oder Teilergebnisse des Benutzers.
 */
public class Input {
    /**
       Die komplette InputMask als HTML in String gespeichert.
     */
    private String InputMask;
    SearchID sid;
    public Input(SearchID id) {
      sid = id;
    }
    
    /**
       @roseuid 379DB40E0208
       diese Methode kann auch ueberschrieben und erweitert werden
     */
    public StartConcept createStartConcept(T_Box tbox) {
      // globale tbox an Concept-Konstruktor????
      Concept C1 = tbox.lookup("companyname");
      Concept C2 = tbox.lookup("trade");
      Concept C3 = tbox.lookup("productname");
      Concept C4 = tbox.lookup("keyword");


      LinkedList Elements = new LinkedList();
      LinkedList V = new LinkedList();
      LinkedList V2 = new LinkedList();
      //Combobox Elemente
      /* Namen fuer die ComboBox automatisch aus der T-Box erzeugen
	 Es handelt sich dabei um die Konzepte unter dem Konzept Compage
	 Gruss Nils
       */
      ListIterator li=tbox.getSubsumedConcepts(tbox.lookup("compage")).listIterator();
      while(li.hasNext()) V.add(((Concept)li.next()).name);      

      TextBoxElement TE1 = new TextBoxElement("Name", false, C1);      
      ComboBoxElement CE1 = new ComboBoxElement("-----",V, "Branche", false, C2);
      TextBoxElement TE2 = new TextBoxElement("Produkt", false, C3);      
      TextBoxElement TE3 = new TextBoxElement("Stichwort", false, C4);      

      Elements.add(TE1);
      Elements.add(CE1);
      Elements.add(TE2);
      Elements.add(TE3);

      StartConcept Start = new StartConcept("FirmenSearch", Elements, sid);

      return Start;

    }
}
