// Source file: ../../sourcen/shell/io/InputmaskServlet.java

//package io;

import io.StartConcept;
import systemcontrol.*;
import exceptions.*;
import java.io.*;
import java.util.*;
import informationexchange.LogService;
import javax.servlet.*;
import javax.servlet.http.*;


/**
   Servlet
   @author Niels Schroeter
   @version 1.0 4.8.1999
 */
public class InputmaskServlet extends HttpServlet
{    
  SearchID sid;
  String configfilepath = "";
    /**
       @roseuid 37A82B6893C0
     */
   public void init(ServletConfig config) {     
     configfilepath = config.getInitParameter("configfile");
   }
    
    /**
       @roseuid 37A82B8363F0
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response)  
       throws ServletException, IOException
    {

      PrintWriter      out;
      String inputMask="";

      //instanziiere Flowcontrol
      LogService.log(100,this,"instanziiere Flowcontrol...");
      Flowcontrol flow = new Flowcontrol(configfilepath);
      LogService.log(0,this,"Flowcontrol created");      

      // set content type and other response header fields first
      response.setContentType("text/html");
      
      // then write the data of the response
      out = response.getWriter();
	  
      //generiere fuer eine Suche noetige Objekte 
      try{
      try{
      try {
      try {
	try {
	  LogService.log(100,this,"create required objects to perform search...");
	  flow.createSessionObjects();
 
	  LogService.log(100,this,"create StartConcept...");

	  MainTable mt = Flowcontrol.getMainTable();
	  MainElement me = mt.getMainElement(flow.getSearchID());
	    LogService.log(400,this, (mt.getMainElement(flow.getSearchID())).getSearchID().getSearchIDString());
	  StartConcept s = me.getStartConcept();
	
	  /* Den Servlet-Path des Aufrufs speichern */
	  String servletfullpath=request.getServletPath();
	  s.setServletpath(servletfullpath.substring(0,servletfullpath.lastIndexOf("/")));
	  LogService.log(100,this,"generate Input Mask...");
	  s.generateInputMask();
	  inputMask=s.getHTML();
	  
	  //LogService.log(100,this,"Set Global static EndSearch Bool to false");
	  
	}catch (TBoxLoadErrorException e) {out.println(e.toString());
	LogService.log(400,this,"Der schwere Ausnahmefehler 400 ist aufgetreten: "+e.toString());
	out.println("Die Suche kann nicht durchgefuehrt werden.");
	out.close();
	}
      }catch (ABoxLoadErrorException e) {out.println(e.toString());
      LogService.log(400,this,"Der schwere Ausnahmefehler 400 ist aufgetreten: "+e.toString());
      out.println("Die Suche kann nicht durchgefuehrt werden.");
      out.close();}
      }catch (ClassNotFoundException e) {out.println(e.toString());
      LogService.log(400,this,"Der schwere Ausnahmefehler 400 ist aufgetreten: "+e.toString());
      out.println("Die Suche kann nicht durchgefuehrt werden.");
      out.close();}
      }catch (FileNotFoundException e) {out.println(e.toString());
      LogService.log(400,this,"Der schwere Ausnahmefehler 400 ist aufgetreten: "+e.toString());
      out.println("Die Suche kann nicht durchgefuehrt werden.");
      out.close();} 
      }catch (IOException e) {out.println(e.toString());
      LogService.log(400,this,"Der schwere Ausnahmefehler 400 ist aufgetreten: "+e.toString());
      out.println("Die Suche kann nicht durchgefuehrt werden.");
      out.close();}
      
      //hole inputMask
      out.println(inputMask);

      out.close();
    }
    
    
    /**
       @roseuid 37A82C2312D0
     */
     public void doPost(HttpServletRequest req, HttpServletResponse res) {

     }
}
