// Source file: ../../sourcen/shell/io/ProcessInputServlet.java

//package io;

import systemcontrol.Flowcontrol;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.net.*;
import io.StartConcept;
import io.ComboBoxElement;
import io.TextBoxElement;
import io.CheckBoxElement;
import io.Element;
import knowledge.T_Box;
import knowledge.A_Box;
import exceptions.*;
import operators.OperatorDB;
import informationexchange.LogService;


/**
   @author Niels Schroeter
 */



public class ProcessInputServlet extends HttpServlet {


  String values[]; 
  long id = 0; 
  int reload = 0;


    
    /**
       @roseuid 37A975D5B900
     */
  public void init(ServletConfig config) {
    }
    
    /**
       @roseuid 37A975F14148
     */
  public void doGet(HttpServletRequest req, HttpServletResponse res) 
      throws ServletException, IOException {

    PrintWriter		out;
    out = res.getWriter();

    T_Box tbox=(Flowcontrol.getMainTable()).getGlobalT_Box();
    A_Box abox=(Flowcontrol.getMainTable()).getGlobalA_Box();
    OperatorDB operatorDB=(Flowcontrol.getMainTable()).getOperatorDB();

    Flowcontrol flow; 
    StartConcept s;

      /* Den Servlet-Path des Aufrufs speichern */
      String servletfullpath=req.getServletPath();
      String servletpath=  (servletfullpath.substring(0,servletfullpath.lastIndexOf("/")));
      LogService.log(0,this,"analysiere parameter...");
    Enumeration enum = req.getParameterNames();
    while (enum.hasMoreElements())
      {
	String name = (String) enum.nextElement();
	values = req.getParameterValues(name);
	if (values != null)
	  {
	    for (int i=0; i<values.length; i++)
	      {		
		int zeile=0;
		String var="";
		  
		zeile=Integer.parseInt(name.substring(0,2));
		var=name.substring(2);	  


		if (var.equals("SearchID"))
		  {
		    String sid = values[i];
		    id = Long.parseLong(sid);	   
		  }
		if (var.equals("neugirig"))
		  {
		    String sreload = values[i];
		    try {
		      reload = Integer.parseInt(sreload);
		    }
		    catch(NumberFormatException e) {reload = 0;}
		  }	      
	      }
	  }
      }
    
    if ((Flowcontrol.getMainTable()).getMainElement(id)!=null)
      {
    
    flow=((Flowcontrol.getMainTable()).getMainElement(id)).getFlowcontrol();      
    s=((Flowcontrol.getMainTable()).getMainElement(id)).getStartConcept();

    enum = req.getParameterNames();


 
    while (enum.hasMoreElements())
      {
        LogService.log(0,this,"naechstes element");
        String name = (String) enum.nextElement();
        LogService.log(0,this,"hole parameter inhalt");
        values = req.getParameterValues(name);
        if (values != null)
          {
            LogService.log(0,this,"inhalt ungleich null");
            for (int i=0; i<values.length; i++)
              {
                LogService.log(0,this,"index "+i);
                int zeile=0;
                String var="";
                LogService.log(0,this,"wandle string in integer um");
                zeile=Integer.parseInt(name.substring(0,2));
                var=name.substring(2);
                if (var.equals("Concept"))
                  {
                    LogService.log(0,this,"parameter name gleich concept");
                    if (s==null) {LogService.log(0,this,"startconcept gleich null");}
                    if (s.getElement()==null) {LogService.log(0,this,"s.getelement gleich null");}
                    if (s.getElement().get(zeile)==null) {LogService.log(0,this,"s.getelementgetzeile gleich null");}
                    Element tmp = (Element)s.getElement().get(zeile);
                    LogService.log(0,this,"switch textbox combobox");
                    switch (tmp.getType())
                      {
                      case 1:
                        {
                          LogService.log(0,this,"textbox");
                          TextBoxElement tmp1 = (TextBoxElement)tmp; 
                          tmp1.setContent(values[i]);
                          break;
                        }
                      case 2:
                        {
                          LogService.log(0,this,"combobox");
                          ComboBoxElement tmp2 = (ComboBoxElement)tmp; 
                          // fuer firmenagent shell
                          // wenn concept = "-----", dann egal
                          if (values[i].equals("-----")) {values[i]="";}
                          tmp2.setContent(values[i]);
                          break;
                        }
                      
                      }             
                  }
                if (var.equals("isGoal"))
                  {
                    LogService.log(0,this,"combobox");
                    Element tmp = (Element)s.getElement().get(zeile);
                    tmp.setGoalButtonChecked(true);
                  }
                
              }
          }
      }
      LogService.log(0,this,"parameter analysiert");


      LogService.log(0,this,"teste eingabe auf korrektheit");
      boolean eingabeKorrekt = s.korrekt();


      if (eingabeKorrekt) {System.out.println("korrekte eingabe");
      LogService.log(0,this,"call startsearch");
      try {
	flow.startSearch(s,tbox,abox);    // am ende wird noch operatordb uebergeben
      }catch (NoTargetPathException e) {out.println("<b>NoTargetPathException: Die Suche kann nicht durchgefuehrt werden."); 

      out.close();} 
      
      // set content type and other response header fields first
      res.setContentType("text/html");
      
      

	// then write the data of the response
        if (reload==0) {	
	  out.println("<HTML><HEAD><TITLE>");
	  out.println("Suchagent");
	  out.println("</TITLE></HEAD><H1>Please stand by...</H1><BODY>");
	  out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/PartialResultsServlet\">");
	  out.println("<INPUT TYPE=hidden name=\"SearchID\" value="+id+">");
	  out.println("<INPUT TYPE=SUBMIT VALUE=ZWISCHENERGEBNISSE></form>");
	  out.println("<FORM METHOD=GET ACTION=\""+servletpath+"/AbortServlet\">");
	  out.println("<INPUT TYPE=hidden name=\"SearchID\" value="+id+">");
	  out.println("<INPUT TYPE=SUBMIT VALUE=ABORT></form>");
	  out.println("</BODY></HTML>");
	  out.println("<SCRIPT LANGUAGE=\"javascript\">");
	  out.println("<!-- ");
	  out.println("window.open('"+servletpath+"/OutputmaskServlet?SearchID="+id+"&reload="+reload+"', '_geo_toto')");
	  out.println("// -->");
	  out.println("</SCRIPT>");
	}
	else {
	  out.println("<HTML><HEAD><meta http-equiv=\"refresh\" content=\"1; "
		      +"URL="+servletpath+"/OutputmaskServlet?SearchID="+id+"&reload="+reload+"\">");
	  out.println("<TITLE>");
	  out.println("Suchagent");
	  out.println("</TITLE></HEAD><BODY><H1>Please stand by...</H1>");
	}
	out.close(); 

      }
      else {
	erneuteEingabe(out, s, res);
      }
      }
    else {
      res.setContentType("text/html");
      out = res.getWriter();
      out.println("<HTML><body>");
      out.println("ERROR: SearchID non-existent or Search expired...");
      out.close();
    }
    }
    
    /**
       @roseuid 37A976199978
     */
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
    }
  

  public void erneuteEingabe(PrintWriter out, StartConcept s, HttpServletResponse res) {
      res.setContentType("text/html");

      out.println("<center><h4>Bitte korrigieren Sie Ihre Eingaben!</h4></center> <br><br>");
      s.generateInputMask();
      String inputMask=s.getHTML();
      out.println(inputMask);
      out.close(); 


  }
}






