// Source file: ../../sourcen/shell/io/StartConcept.java

package io;

import java.util.LinkedList;
import knowledge.A_Box;
import knowledge.T_Box;
import knowledge.Instance;
import knowledge.Concept;
import systemcontrol.*;
import knowledge.Role;
import exceptions.*;

/**
   Beinhaltet das Aussehen der Eingabemaske,
   die Eingabekonzepte und Ihre Inhalte
 */
public class StartConcept {
    /**
       Ueberschrift der Eingabemaske
     */
    private String header;
    /**
       LinkedList von Elementen zu einem Startkonzept
     */
    private LinkedList elements;
    private String inputmask;
    private SearchID sid;
    /**
       Pfad zum Servlet, der im Browser bei der URL-Eingabe erscheinen soll
    */
    private String servletpath;
    /**
       generiert die Eingabemaske im HTML-Format
       @roseuid 3799DDDF00C8
     */
    public void generateInputMask() {
      String HtmlText = "";

      inputmask = "<html><head><meta http-equiv=\"expires\" content=\"0\"><title>"+header+"</title></head><body>";

      inputmask = inputmask+"Folgende Eingabekombinationen sind erlaubt:<br>"+
	"<center><table><tr><th>Name</th><th>Branche</th><th>Produkt</th></tr>"+
	"<tr><td align = center>x</td><td align = center>x</td><td align = center>x</td><td align = center> </td></tr>"+

	"<tr><td align = center>x</td><td align = center>x</td><td align = center> </td></tr>"+

	"<tr><td align = center> </td><td align = center>x</td><td align = center>x</td></tr>"+

	"<tr><td align = center>x</td><td align = center> </td><td align = center> </td></tr>"+

	"<tr><td align = center>x</td><td align = center> </td><td align = center>x</td></tr></table></center>"+

	"<br>Nicht zugelassen sind nur Branche und Produkt allein. "+
	"Zu allen g&uuml;ltigen Eingaben k&ouml;nnen Sie auch ein oder mehrere Stichw&ouml;rter eingeben. <br>"+
	"Mehrere Stichw&ouml;rter m&uuml;ssen durch Leerzeichen getrennt werden. Falls Sie einen kompletten "+
	"Satz eingeben m&ouml;chten, m&uuml;ssen Sie ihn in Anf&uuml;hrungszeichen setzen.";
           
      String id = sid.getSearchIDString();
      inputmask = inputmask+"<form METHOD=GET ACTION=\""+servletpath+"/ProcessInputServlet\"><table>";

      for (int i=0; i<elements.size(); i++) {
	Element dummy = (Element)elements.get(i);
	switch(dummy.typ) {
	case 1: {
	  TextBoxElement TextBoxDummy = (TextBoxElement)elements.get(i);
	  HtmlText = HtmlText+TextBoxDummy.generateElement(i);
	  break;
	}
	case 2: {
	  ComboBoxElement ComboBoxDummy = (ComboBoxElement)elements.get(i);
	  HtmlText = HtmlText+ComboBoxDummy.generateElement(i);
	  break;
	}
	case 3: {
	  CheckBoxElement CheckBoxDummy = (CheckBoxElement)elements.get(i);
	  HtmlText = HtmlText+CheckBoxDummy.generateElement(i);
	  break;
	}
	}
      }
      inputmask = inputmask+HtmlText
		+"<input type=hidden name=\"10SearchID\" value="+id+">"
	+"</table>";
      inputmask = inputmask
	+"<input type=text size=3 maxlength=3 name=\"99neugirig\" value=30>"
	+"Hier k&ouml;nnen Sie einstellen, ob Sie die bereits vorhandenen Ergebnisse nach" 
	+"  einer bestimmten Zeit sehen m&ouml;chten. Die Zeit in Sekunden k&ouml;nnen Sie einstellen."
	+" 0 bedeutet, da&szlig; die Zwischenergebnisse in einem separaten Fenster, nachdem Sie den Zwischenergebnisbutton"
	+" dr&uuml;cken, angezeigt werden.<br>"
	+"<INPUT TYPE=SUBMIT VALUE=OK></form></body></html>";
    }
    
    /**
       liefert den HTML-Code der Eingabemaske
       @roseuid 3799DE530104
     */
    public String getHTML() {
	return inputmask;
    }
    
    /**
       Die als Ziele markierten Elemente der Eingabemaske werden in der T-Box markiert.
       @roseuid 37A5586C7660
     */
    public void extractGoal(T_Box tbox) {
	String Inhalt="";	
      for (int i=0; i<elements.size(); i++) {
      	Element tmp = (Element)elements.get(i);
	Inhalt = tmp.getContent();

	//if (!Inhalt.equals("")&&i==1) {
	//tbox.markAsTarget(tbox.lookup(Inhalt));
	//} 
	
	if (!Inhalt.equals("")&&i==2) { 
	  tbox.markAsTarget(tbox.lookupRole("has_productpage"));
	  tbox.markAsTarget(tbox.lookupRole("contains_productname"));

	}
	if (!Inhalt.equals("")&&i==3) { 
	  tbox.markAsTarget(tbox.lookupRole("contains_keyword"));
	}
      }
      tbox.markAsTarget(tbox.lookupRole("has_compage"));
    }
    
    /**
       Die vom Benutzer ausgefuellten und nicht als Ziel markierten Elemente der Eingabemaske, werden in der A-Box markiert.
       @roseuid 37BBC30A12F0
     */
   public void markInstance(A_Box abox, T_Box tbox) {
     String Inhalt = "";
     String Companyname = "";
     boolean company = false;
     String Productname = "";
      boolean product = false;
      boolean Goal;
      Instance ComIns = null;
      Instance ProductIns = null;
      try {
      for (int i=0; i<elements.size(); i++) {
	Element tmp = (Element)elements.get(i);
	Goal = tmp.getGoalButtonChecked();
	Inhalt = tmp.getContent();
	if (!Inhalt.equals("")&&i==0)
	  {
	    Companyname = Inhalt;
	    company = true;
	    ComIns = new Instance(Inhalt.toLowerCase());
	    Concept C = tmp.getConcept();
	    ComIns.addConcept(C,1);
	    abox.setInstance(ComIns);
	    abox.markAsConstraint(ComIns);
	  }
	if (!Inhalt.equals("")&&i==2)
	  {
	    Productname = Inhalt;
	    product = true;
	    ProductIns = new Instance(Inhalt.toLowerCase());
	    Concept C = tmp.getConcept();
	    ProductIns.addConcept(C,1);
	    abox.setInstance(ProductIns);
	    abox.markAsConstraint(ProductIns);
	  }
	if (!Inhalt.equals("")&&i==3)
	  {
	    Instance I = new Instance(Inhalt.toLowerCase());
	    Concept C = tmp.getConcept();
	    I.addConcept(C,1);
	    abox.setInstance(I);
	    abox.markAsConstraint(I);
	  }
	// nicht in combobox ausgewaehlt
	if (Inhalt.equals("")&&tmp.getType()==2)
	  {
	    LinkedList Dummy = abox.getInstances(tmp.getConcept());
	    for (int j=0; j<Dummy.size(); j++)
	      {
		Instance Ins = (Instance)Dummy.get(j);

		abox.markAsConstraint(Ins);
		if (company)
		  ComIns.insertNewRole(tbox.lookupRole("in_trade"), Ins,1);
	      }
	  }
	// es ist eine branche in combobox ausgewaehlt
	if (!Inhalt.equals("")&&tmp.getType()==2) { 
	  LinkedList Dummy = abox.find(Inhalt);
	  for (int j=0; j<Dummy.size(); j++)
	    {
	      Instance Ins = (Instance)Dummy.get(j);
	      abox.markAsConstraint(Ins);
	      if (company)
		ComIns.insertNewRole(tbox.lookupRole("in_trade"), Ins,1);	      
	    }
	}
      }
      if (company&&product)
	{
	  ComIns.insertNewRole(tbox.lookupRole("deals_in"), ProductIns,1);	      
	}
      

	    
      } catch (ConcreteRoleAddInstanceException e) {System.out.println(e.toString());} 
        catch (RoleNotFoundException e2) {System.out.println(e2.toString());}
   }
    /**
       @roseuid 37BBC4D026B0
     */
    public StartConcept(SearchID id) {
    }
    
    /**
       @roseuid 37BBC4FF16F8
     */
    public LinkedList getElement() {
    return elements;
    }
    
    /**
       @roseuid 37BBC53B9760
     */
    public StartConcept(String header, LinkedList elements, SearchID sid) {
	this.header = header;
	this.elements = elements;
	this.sid = sid;
	
    }
  public boolean korrekt() {
    String Inhalt = "";
    boolean correct=false;
    boolean name=false;
    boolean branche=false;
    boolean produkt=false;

    for (int i=0; i<elements.size(); i++) {
      Element tmp = (Element)elements.get(i);
	
      Inhalt = tmp.getContent();
      if (!Inhalt.equals("")&&i==0) { 
	name=true;
      }
      if (!Inhalt.equals("")&&i==1) { 
	branche=true;
      }
      if (!Inhalt.equals("")&&i==2) { 
	produkt=true;
      }
    }
    
    if (name) {correct=true;}
    if (!name&&branche&&produkt) {correct=true;}
      
    return correct;
      
  }
    public void setServletpath(String s){
	this.servletpath=s;
   
    }

}
