package operators;
import informationexchange.LogService;
import knowledge.*;
import java.util.Iterator;
import exceptions.*;
import java.util.LinkedList;
import knowledge.*;
import java.util.StringTokenizer;
import dataprovider.net.*;
import dataprovider.enumerationobjects.*;

/**
   automatisch erzeugter OperatorCompageContainsKeywordOperator
   @author Michael Banken
   @version 1.0 (10.12.1999)
*/
public class CompageContainsKeywordOperator extends Operator{
  /**
     Eval-Methode des Operators.
     Naeheres siehe {@link operators.Operator#eval()}.
  */
  public void eval() throws OperatorFailedException{
   int evalResult;
   String evalKeyword;     
   String evalCompageText;
   String evalComname;
   String evalPageContentNextWord;
   NetEntity evalCompage;
   HTMLTextNetResult evalHtmlpage;
   boolean found = false;

   /* Initialisierung der Variablen */
    
	this.postcondFullfilled=0;
	try
         {
          /* Keyword wird ausgelesen */
          Instance evalKeywordInstance = (Instance) (this.precond[0].getPredArg(0).getInstance()); 
          evalKeyword = evalKeywordInstance.name;
          /* Company-Name wird ausgelesen */
          Instance evalComnameInstance = (Instance) (this.precond[1].getPredArg(0).getInstance()); 
          evalComname = evalComnameInstance.name;
          /* HTML-Seite wird ausgelesen */ 
          evalCompage = (HTMLTextNetResult)(this.precond[1].getPredArg(1).getInstance().getNetEntity());
          /* Umwandlung der Seite in einen String */
          evalCompageText = evalCompage.getText();
          /* Umwandlung des HTMLTextNetResult und des Keywords komplett in Kleinschreibung */
          evalCompageText.toLowerCase();
          evalKeyword.toLowerCase();   
          /* Ueberpruefung, ob das Wort mit dem Keyword uebereinstimmt */
	  evalResult = evalCompageText.indexOf(evalKeyword, 0);
	  if (evalResult >= 0)
	    {
	      /*Wort enthaelt Keyword */ 
	      found = true;
	    };
          if (found == true)
	   {
	    /* Eintragung ins LogFile */  
            LogService.logOperator(this,this.getClass()+": Keyword "+evalKeyword+" in Page("+evalCompage.getURL()+") matches.");
           }
          else
	   {
	    /* Exception wird aufgerufen */ 
            throw new OperatorFailedException(this.getClass()+": Keyword "+evalKeyword+" in Page("+evalCompage.getURL()+") not found.");
           }
         } 
	catch(NullPointerException e)
         {
	  LogService.logOperator(this,this.getClass()+": "+e.toString());
	 } 
	catch(exceptions.NetResultReloadFailedException e)
	 {
          LogService.logOperator(this,this.getClass()+": "+e.toString());
         }
  }

  public CompageContainsKeywordOperator(){
    /* 2 Vorbedingung(en) */
    this.precond=new Predicate[2];
    /* Vorbedindungsprdikat 0 */
    this.precond[0]=new Predicate(1,"keyword");

    PredArgument key = new PredArgument("key");
    key.setCreatesWorldObject(false);
    this.precond[0].setPredArg(key, 0);
    /* Vorbedindungsprdikat 1 */
    this.precond[1]=new Predicate(2,"has_compage");
  
    PredArgument comname = new PredArgument("comname");
    comname.setCreatesWorldObject(false);
    this.precond[1].setPredArg(comname, 0);
    PredArgument compage = new PredArgument("compage");
    compage.setCreatesWorldObject(false);
    this.precond[1].setPredArg(compage, 1);

    Predicate pred;
    /* 1 Nachbedingung(en) */
    this.postconds=new Postcondition[1];

    /* Nachbedingung 0 */
    this.postconds[0]=new Postcondition();
    /* AddList */
    pred=new Predicate(2,"contains_keyword");
    pred.setPredArg(compage, 0);
    pred.setPredArg(key, 1);


    this.postconds[0].addAddListPred(pred);

    /* DeleteList */
  }
}
