/// Source file: ../../sourcen/shell/systemcontrol/Flowcontrol.java

package systemcontrol;

import java.util.EventListener;
import java.io.*;
import io.Output;
import informationexchange.FirmenAgentPlanInformation;
import informationexchange.LogService;
import planner.PlanExecution;
import systemcontrol.Interfaces.Learner.I_Learner;
import java.util.Vector;
import io.Input;
import dataanalysis.databases.ClassifierDatabase;
import planner.Planner;
import knowledge.A_Box;
import knowledge.T_Box;
import knowledge.PlanArchive;
import knowledge.Concept;
import exceptions.LoadErrorException;
import io.StartConcept;
import systemcontrol.event.ShellEventListener;
import java.io.IOException;
import operators.OperatorDB;
import planner.plannertypes.PlannerTypeC;
import planner.plannertypes.PlannerTypeA;
import java.io.FileNotFoundException;
import exceptions.ABoxLoadErrorException;
import exceptions.TBoxLoadErrorException;
import systemcontrol.event.ShellEventAdapter;
import exceptions.NoTargetPathException;
import java.util.Properties;

import learners.InstanceLearner;

/**
   Die Ablaufkontrolle steuert den gesamten Suchablauf,
   die Kommunikation zwischen verschiedenen Komponenten,
   reagiert auf Events, startet Threads wie Planer, PA
 */
public class Flowcontrol {

  static public MainTable mainTable;

  /*
    static public Object EventListener = new Object();
    static ResultsList results;
    static public PlanArchive planArchive;
  */

  Object EventListener = new Object();
  ResultsList results;
  PlanArchive planArchive;
  Input input;
  Output output;
  StartConcept Start;

  SearchID sid;
 
  A_Box abox;
  T_Box tbox;
  ClassifierDatabase classDatabase;
  OperatorDB operatorDB;
    String instanceLearnerDatei = "";
  String ABoxDatei = "";
  String ABoxObject = "";
  String TBoxDatei = "";
  String OperatorDBDatei = "";
  String OperatorDBObject = "";
  String ClassDatabaseDatei = "";
  String configfilepath = "";
  String planarchivpath = "";
  private ShellEventAdapter sea;
  boolean saveClassDB = false;
  static String proxySet = "";
  static String proxyHost = "";
  static String proxyPort = "";
  static int maxInstances;
  static int life;
  public Reference_table rt = new Reference_table();
    
    /**
       Die Methode instanziiert alle Objekte, die fuer eine Suche notwendig sind. 
       Liefert Sie im Array zurueck.
       @roseuid 37A9774C6EF8
     */
    public void createSessionObjects() 
       throws ClassNotFoundException, IOException, TBoxLoadErrorException, ABoxLoadErrorException, FileNotFoundException{
      sid = new SearchID();
      input = new Input(sid);
      // Dateinamen aus Konfigurationsdatei laden

      BufferedReader f;
      String line;
      String wd="";
      String lf="";
      String ll="";
	  LogService.log(100,this,configfilepath);
      
      try {
	f = new BufferedReader(new FileReader(configfilepath));
	while ((line = f.readLine()) != null) {

	  if (line.startsWith("Working Directory"))
	    {
	      wd=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      LogService.log(100,this,"current Working Directory set to: "+wd);
	    }
	  if (line.startsWith("logfileName"))
	    {
	      lf=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!lf.startsWith("/"))
		{
		  lf=wd+"/"+lf;
		}
	      LogService.log(100,this,"logFilename set to: "+lf);
	      LogService.logfileName=lf;
	    }
	  if (line.startsWith("logLevel"))
	    {
	      ll=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      LogService.log(100,this,"set log level to: "+ll);
	      LogService.logLevel=Integer.parseInt(ll);
	    }
	  if (line.startsWith("InstanceLearnerDatei"))
	    {
	      instanceLearnerDatei=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!instanceLearnerDatei.startsWith("/"))
		{
		  instanceLearnerDatei=wd+"/"+instanceLearnerDatei;
		}
	      LogService.log(100,this,"set InstanceLearner filename to: "+instanceLearnerDatei);
	    }
	  if (line.startsWith("A_BoxDatei"))
	    {
	      ABoxDatei=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!ABoxDatei.startsWith("/"))
		{
		  ABoxDatei=wd+"/"+ABoxDatei;
		}
	      LogService.log(100,this,"set abox filename to: "+ABoxDatei);
	    }
	  if (line.startsWith("PlanArchiv"))
	    {
	      planarchivpath=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!planarchivpath.startsWith("/"))
		{
		  planarchivpath=wd+"/"+planarchivpath;
		}
	      LogService.log(100,this,"set plan archiv path to: "+planarchivpath);
	    }
	  if (line.startsWith("A_BoxObject"))
	    {
	      ABoxObject=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!ABoxObject.startsWith("/"))
		{
		  ABoxObject=wd+"/"+ABoxObject;
		}
	      LogService.log(100,this,"set abox Object filename to: "+ABoxObject);
	    }
	  if (line.startsWith("T_Box"))
	    {
	      TBoxDatei=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!TBoxDatei.startsWith("/"))
	      {
		TBoxDatei=wd+"/"+TBoxDatei;
	      }
	      LogService.log(100,this,"set tbox filename to: "+TBoxDatei);
	    }
	  if (line.startsWith("OperatorDBDatei"))
	    {
	      OperatorDBDatei=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!OperatorDBDatei.startsWith("/"))
		{
		  OperatorDBDatei=wd+"/"+OperatorDBDatei;
		}
	      LogService.log(100,this,"set Operator DB Filename to: "+OperatorDBDatei);
	    }
	  if (line.startsWith("OperatorDBObject"))
	    {
	      OperatorDBObject=(line.substring(line.indexOf("=")+1,line.length())).trim();
	       if (!OperatorDBObject.startsWith("/"))
		{
		  OperatorDBObject=wd+"/"+OperatorDBObject;
		}
	      LogService.log(100,this,"set Operator DB OBJECT Filename to: "+OperatorDBObject);
	    }
	  if (line.startsWith("ClassDatabase"))
	    {
	      ClassDatabaseDatei=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (!ClassDatabaseDatei.startsWith("/"))
		{
		  ClassDatabaseDatei=wd+"/"+ClassDatabaseDatei;
		}
	      LogService.log(100,this,"set ClassDatabase Filename to: "+ClassDatabaseDatei);
	    }
	  if (line.startsWith("SaveClassDB"))
	     {
	      String Dummy=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      if (Dummy.equals("true"))
		{
		  LogService.log(100,this,"Classdatabase will be saved on search finished");
		  saveClassDB = true;
		}
	      if (Dummy.equals("false"))
		{
		  LogService.log(100,this,"Classdatabase will NOT be save on search finished");
		  saveClassDB = false;
		}
	    }
	  if (line.startsWith("proxySet"))
	    {
	      String Dummy=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      proxySet = Dummy;
	    }
	  if (line.startsWith("proxyHost"))
	    {
	      String Dummy=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      proxyHost = Dummy;
	    }
	  if (line.startsWith("proxyPort"))
	    {
	      String Dummy=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      proxyPort = Dummy;
	    }
	  if (line.startsWith("maxInstances"))
	    {
	      String Dummy=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      maxInstances = Integer.parseInt(Dummy);
	    }
	  if (line.startsWith("enddate"))
	    {
	      String Dummy=(line.substring(line.indexOf("=")+1,line.length())).trim();
	      life = Integer.parseInt(Dummy);
	    }	}
	f.close();
      } catch (IOException e) {
	LogService.log(400,this,"FATAL ERROR 400: couldn't read config.sys... please reinstall Windows");
      }
      
      setProxysettings();


      //Main Table erzeugen, A-Box, T-Box, OperatorDB, ClassifierDB laden
      if (mainTable == null) {
	LogService.log(100,this,"Try to load Classifier Database...");
	loadClassDatabase(ClassDatabaseDatei);
	LogService.log(100,this,"Classifier Database was loaded successfully");

	loadAandTBox(classDatabase);
	LogService.log(100,this,"loadAandTBox(classDatabase)");

	LogService.log(100,this,"Try to load Operator DB...");
	loadOperatorDB(OperatorDBDatei);
	LogService.log(100,this,"OperatorDB was loaded successfully");
	mainTable = new MainTable(classDatabase, operatorDB, abox, tbox, life);
      }
      //Sonst geladene Objecte aus MainTable holen
      else {
	LogService.log(100,this,"Objekte existieren bereits");
	abox = mainTable.getGlobalA_Box();
	tbox = mainTable.getGlobalT_Box();
	classDatabase = mainTable.getClassifierDatabase();
	operatorDB = mainTable.getOperatorDB();
      }

      //StartConzept erzeugen
      Start = input.createStartConcept(tbox);
      
      planArchive = new PlanArchive();

      results = new ResultsList();
      output = new Output();

      sea = new ShellEventAdapter(rt);
      //EventListener = (mainTable.getMainElement(sid)).getEventListener();
      EventListener = sea;


      // MainElement erzeugen und in die MainTable einfuegen.
      mainTable.setMainElement(new MainElement(EventListener, results, planArchive, sid, rt,
					       input, output, Start, this));
      mainTable.druck();

    }
    

  

    /**
       @roseuid 37C109AD2B60
     */
    public Flowcontrol(String configfilepath) {
      this.configfilepath = configfilepath;
    }
    
    /**
       Erzeugt FirmenAgentPlanInformationObjekt, startet einen Planner.
       @roseuid 37C109F92090
     */
    public void startSearch(StartConcept s, T_Box tbox, A_Box abox) 
      throws NoTargetPathException{

      LogService.log(100,this,"*****Searchstart*****"+sid.getSearchID());

      A_Box cloneABox = (A_Box)abox.clone();
      T_Box cloneTBox = (T_Box)tbox.clone();
 

      // extractGoal aufrufen
      LogService.log(0,this,"Extrahiere Ziel");
      s.extractGoal(cloneTBox);

      // markInstance aufrufen
      LogService.log(0,this,"Mark Instance");
      s.markInstance(cloneABox,cloneTBox);

     LogService.log(0,this,"Search ID generated: "+sid);

      // FirmenAgentPlanInformationen erzeugen
      PlanID plid1 = new PlanID();  
      A_Box cloneABox1 = (A_Box)cloneABox.clone();
      T_Box cloneTBox1 = (T_Box)cloneTBox.clone();
      LogService.log(0,this,"create planinfo 1");
      FirmenAgentPlanInformation pi1 = new FirmenAgentPlanInformation
	(plid1.getPlanID(),sid.getSearchID(),cloneABox1,cloneTBox1,operatorDB,true);
      PlanID plid2 = new PlanID();
      A_Box cloneABox2 = (A_Box)cloneABox.clone();
      T_Box cloneTBox2 = (T_Box)cloneTBox.clone();
      LogService.log(0,this,"create planinfo 2");
      FirmenAgentPlanInformation pi2 = new FirmenAgentPlanInformation
	(plid2.getPlanID(),sid.getSearchID(),cloneABox2,cloneTBox2,operatorDB,true);
      
      sea = new ShellEventAdapter(rt);
      EventListener = sea;
      
      // Hier Planner A auskommentieren 
      // 2 Planner-Threadsstarten
      //      PlannerTypeA plan1 = new PlannerTypeA(pi1);
      //      rt.add(pi1, plan1);
      PlannerTypeC plan2 = new PlannerTypeC(pi2);
      rt.add(pi2, plan2);
      
      //      plan1.start();
      plan2.start(); 

    }
  public static void setResults(Results res, SearchID sid) {
    mainTable.getResultsList(sid).add(res);
  }
  public static ResultsList getResults(SearchID sid) {
    return mainTable.getResultsList(sid);
  }

  public static ResultsList getResults(long sid) {
    return mainTable.getResultsList(sid);
  }

  public  void endSearch() throws IOException{
    // Planarchiv speichern
    ObjectOutputStream out;
    ObjectInputStream in;
    PlanArchive pa = getMainTable().getPlanArchive(sid.getSearchID());
    try {
    // Planarchiv speichern
      out = new ObjectOutputStream(new FileOutputStream(planarchivpath+"/plan_archiv_"+sid.getSearchIDString()));
      out.writeObject(pa);
      out.close();
      LogService.log(100,this,"Planarchive saved successfully");

    // ClassifierDatabase speichern
      if (saveClassDB)
	{
	  File lock = new File(classDatabase+"..lock");
	  while (lock.exists()) {}
	  File setlock = new File(classDatabase+"..lock");
	  setlock.deleteOnExit();
	  LogService.log(100,this,"Trying to save Classifier DB in "+ClassDatabaseDatei);
	  out = new ObjectOutputStream(new FileOutputStream(ClassDatabaseDatei));
	  LogService.log(0,this,"oos generated...");
	  out.writeObject(classDatabase);
	  LogService.log(0,this,"object written...");
	  out.close();
	  LogService.log(100,this,"Classifier Database saved successfully");
	  setlock.delete();
	}
      else
	{
	  LogService.log(100,this,"Classifierdatabase don't wants to be saved...");
	}
      LogService.log(100,this,"*****Searchend*****"+sid.getSearchID());
      
      /*    // OperatorDB speichern
      out = new ObjectOutputStream(new FileOutputStream(OperatorDBObject));
      out.writeObject(operatorDB);
      out.close();
      LogService.log(100,this,"Operator DB saved successfully");*/

     
    //A_Box speichern
//        out = new ObjectOutputStream(new FileOutputStream(ABoxObject));
//        out.writeObject(abox);
//        out.close();
//        LogService.log(100,this,"A_Box (T_Box inside) saved successfully");
    }
    catch(IOException e) {
      LogService.log(400,this,"IO EXECPTION: "+e.toString());
    }
    // Das Enddatum wird festgelegt
    mainTable.setEndDate(sid.getSearchID());
    // Lerner starten und irgendwo auch erzeugen
    InstanceLearner il = new InstanceLearner();
    il.update(planArchive, ABoxObject, instanceLearnerDatei, sid.getSearchID());
    
  }

  /**
     Laedt die ClassifierDatabase
  */
  public void loadClassDatabase(String name) throws ClassNotFoundException, IOException{
    System.out.println("loadClassifierDatabase");
    File lock = new File(name+"..lock");
    while (lock.exists()) {}
    File setlock = new File(name+"..lock");
    setlock.deleteOnExit();
    FileInputStream fs = new FileInputStream(name);
    ObjectInputStream is = new ObjectInputStream(fs);
    classDatabase = (ClassifierDatabase)is.readObject();
    is.close();
    setlock.delete();
  }

  /**
     Laedt die OperatorDB
     Falls es keine OperatorDB gibt wird aus einer textdatei geladen. 
     Sonst wird die Suche abgebrochen.
  */
  public void loadOperatorDB(String name) throws ClassNotFoundException, IOException{
    File odb = new File(OperatorDBObject);
    if (odb.exists())
      {	
	File lock2 = new File(OperatorDBObject+"..lock");
	if (lock2.exists()) {	LogService.log(100,this,"OperatorDB Object locked...Waiting...");}
	while (lock2.exists()) {}
	File setlock2 = new File(OperatorDBObject+"..lock");
	setlock2.deleteOnExit();
	LogService.log(100,this,"Operator DB exists, loading from Objectinputstream...");
	FileInputStream fs = new FileInputStream(OperatorDBObject);
	ObjectInputStream is = new ObjectInputStream(fs);
	operatorDB = (OperatorDB)is.readObject();
	is.close();
	setlock2.delete();
      }
    else
      {
	File lock = new File(name+"..lock");
	if (lock.exists()) {	LogService.log(100,this,"OperatorDB Textfile locked...Waiting...");}
	while (lock.exists()) {}
	File setlock = new File(name+"..lock");
	setlock.deleteOnExit();
	LogService.log(100,this,"No OperatorDB Object available, trying to load from Textfile...");
	Concept c=(tbox.lookup("trade"));
	File lock3 = new File(OperatorDBObject+"..lock");
	if (lock3.exists()) {	LogService.log(100,this,"OperatorDB Object locked...Waiting...");}
	while (lock3.exists()) {}
	File setlock3 = new File(OperatorDBObject+"..lock");
	setlock3.deleteOnExit();
	operatorDB = new OperatorDB(name ,tbox, c, true);
	setlock3.delete();
	LogService.log(100,this,"Now trying to save Operator DB in OOS...");
	//ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(OperatorDBObject));
	//out.writeObject(operatorDB);
	//out.close();
	LogService.log(100,this,"Operator DB Object saved successfully...");
	setlock.delete();
      }
  }
   public void loadAandTBox(ClassifierDatabase cl) throws ABoxLoadErrorException, TBoxLoadErrorException, ClassNotFoundException, IOException{
     File lock = new File(ABoxObject+".lock");
     File wlock = new File(ABoxObject+".wlock");
     File rlock = new File(ABoxObject+".rlock"+sid.getSearchIDString());
     rlock.deleteOnExit();
     File odb = new File(ABoxObject);

     if (! odb.exists())
      {
	  do {
	      while(lock.exists()) { try {Thread.sleep(10);} catch (InterruptedException e){}}
	  } while (! lock.createNewFile());
	LogService.log(100,this,"No A_Box Object available, trying to load A_Box and T_Box from Textfile...");
	LogService.log(100,this,"Creating T_Box");
	tbox = new T_Box(classDatabase);
	
	LogService.log(100,this,"Try to load T_Box...");
	tbox.load(TBoxDatei);
	LogService.log(100,this,"T_Box was loaded successfully from Textfile");
	
	abox = new A_Box(tbox);
	LogService.log(100,this,"Try to load A-Box");
	abox.load(ABoxDatei);
	LogService.log(100,this,"A_Box was loaded successfully from Textfile");
	
	wlock.createNewFile();
	FileOutputStream fs = new FileOutputStream(ABoxObject);
	ObjectOutputStream is = new ObjectOutputStream(fs);
	LogService.log(100,this,"Try to serialize A-Box");
	is.writeObject(abox);
	LogService.log(100,this,"A_Box was serialized successfully");
	is.close();
	wlock.delete();
	lock.delete();
      }

     while (wlock.exists()) {
       try {Thread.sleep(10);} catch (InterruptedException e){}
     }
     rlock.createNewFile();
     LogService.log(100,this,"A_Box OBJECT exists, loading from Objectinputstream...");
     FileInputStream fs = new FileInputStream(ABoxObject);
     ObjectInputStream is = new ObjectInputStream(fs);
     abox = (A_Box)is.readObject();
     is.close();
     LogService.log(100,this,"A_Box was loaded successfully from Objectinputstream");
     tbox = abox.getT_Box();
     tbox.addClassifierDataBase(cl);
     LogService.log(100,this,"T_Box Reference extracted from A_Box...");      
     rlock.delete();
   }
  
  public static void setProxysettings() {          
    Properties systemProperties = System.getProperties();
    systemProperties.put("proxySet", proxySet);
    systemProperties.put("proxyHost", proxyHost);
    systemProperties.put("proxyPort", proxyPort);
    System.setProperties(systemProperties);

  }
  public static int getMaxInstances()
    {return maxInstances;}

  public static MainTable getMainTable() {
    return mainTable;
  }
  public SearchID getSearchID() {
   
    return sid;
  }
  public void druck() {
    mainTable.druck();
  }
}
