// Source file: ../../sourcen/shell/systemcontrol/MainTable.java

package systemcontrol;

import java.util.*;
import systemcontrol.event.*;
import knowledge.*;
import operators.*;
import dataanalysis.databases.*;

/**
   Die Tabelle enthaelt eine Liste. Ein Listenelement enthaelt alle, 
   fuer eine Suche benoetigten Objekte.
   Ausserdem sind hier alle Objekte, die fuer alle Suchen gleich sind gespeichert.
*/
public class MainTable 
{

  private LinkedList mainList = new LinkedList();
  private ClassifierDatabase classifierDB;
  private A_Box abox;
  private T_Box tbox;
  private OperatorDB operatorDB;
  private int life;
  
  
  public MainTable(ClassifierDatabase classifierDB, OperatorDB operatorDB, A_Box abox, T_Box tbox, int lifeEnd) {
    this.abox = abox;
    this.tbox = tbox;
    this.classifierDB = classifierDB;
    this.operatorDB = operatorDB;
    this.life = life;
  }
  public LinkedList getMainList() {
    return mainList;
  }
  /**
     Gibt ein Element der liste aus
  */
  public MainElement getMainElement(SearchID id) {
    MainElement Dummy = null;
   for(int i = 0; i<mainList.size(); i++)
      {
	if ((((MainElement)mainList.get(i)).getSearchID().getSearchID())==id.getSearchID()) {
	  Dummy = (MainElement)mainList.get(i);
	break;}
      }
    return Dummy;
  }
  
  public MainElement getMainElement(long id) {
    MainElement Dummy = null;
   for(int i = 0; i<mainList.size(); i++)
      {
	if ((((MainElement)mainList.get(i)).getSearchID().getSearchID())==id) {
	  Dummy = (MainElement)mainList.get(i); 
	  break;}
      }
    return Dummy;
  }

  public Reference_table getReference_table(SearchID id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if (((MainElement)mainList.get(i)).getSearchID().equals(id)) 
	  return ((MainElement)mainList.get(i)).getReference_table();
      }   
    return null;
  }

  public Reference_table getReference_table(long id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if ((((MainElement)mainList.get(i)).getSearchID().getSearchID())==id)
	  return ((MainElement)mainList.get(i)).getReference_table();
      }   
    return null;
  }

  public Object getEventListener(SearchID id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if (((MainElement)mainList.get(i)).getSearchID().equals(id))
	  return ((MainElement)mainList.get(i)).getEventListener();
      }
    return null;
  }

  public Object getEventListener(long id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if ((((MainElement)mainList.get(i)).getSearchID().getSearchID())==id)
	  return ((MainElement)mainList.get(i)).getEventListener();
      }
    return null;
  }

  public ResultsList getResultsList(SearchID id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if (((MainElement)mainList.get(i)).getSearchID().equals(id))
	  return ((MainElement)mainList.get(i)).getResultsList();
      }
    return null;
  }

  public ResultsList getResultsList(long id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if ((((MainElement)mainList.get(i)).getSearchID().getSearchID())==id)
	  return ((MainElement)mainList.get(i)).getResultsList();
      }
    return null;
  }

  public PlanArchive getPlanArchive(SearchID id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if (((MainElement)mainList.get(i)).getSearchID().equals(id))
	  return ((MainElement)mainList.get(i)).getPlanArchive();
      }
    return null;
  }

  public PlanArchive getPlanArchive(long id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	if ((((MainElement)mainList.get(i)).getSearchID().getSearchID())==id)
	  return ((MainElement)mainList.get(i)).getPlanArchive();
      }
    return null;
  }

  public void setMainElement(MainElement mainEl) {
    mainList.add(mainEl);
  }
  public A_Box getGlobalA_Box() {
    return abox;
  }
  
  public T_Box getGlobalT_Box() {
    return tbox;
  }

  public ClassifierDatabase getClassifierDatabase() {
    return classifierDB;
  }

  public OperatorDB getOperatorDB() {
    return operatorDB;
  }
    
  /**
     Methode nur zu Testzwecken
  */
  public void druck() {
    System.out.println("************MAINTABLE******************");
    for (int i=0; i<mainList.size(); i++) {
      System.out.println("--------------"+i+"---------");
      System.out.println((((MainElement)mainList.get(i)).getSearchID()).getSearchID());
      System.out.println(((MainElement)mainList.get(i)).getStartConcept().toString());
    }
    System.out.println("************MAINTABLE******************");
  }

  public void removeMainElement(long id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	MainElement me = (MainElement)mainList.get(i);
	if ((me.getSearchID()).getSearchID()==id)
	  {
	    me.setDestroy(true);
	    Reference_table rt = me.getReference_table();
	    for (int j=0; j<rt.getReferenceObject().size(); j++) { 
	    PlanObject po = (PlanObject)rt.getReferenceObject().get(j);
	      po.getPlan().myDestroy(); // geht eh nicht
	        if (!(po.getPlanExecution() == null))
	       po.getPlanExecution().myDestroy();
	      }
	    mainList.remove(i);
	  }
      }
    System.out.println("-----------Geloescht-------------");
  }
  public void setEndDate(long id) {
    for(int i = 0; i<mainList.size(); i++)
      {
	MainElement me = (MainElement)mainList.get(i);
	if ((me.getSearchID()).getSearchID()==id)
	  {
	    GregorianCalendar cal = new GregorianCalendar();
	    me.setEndDate(cal.HOUR_OF_DAY);
	  }
      }
  }
  /**
     Fuer jedes Element wird ueberprueft, ob er schon zu lange in der Tabelle
     ist. Falls ja, wird es aus der Tabelle geloescht.
  */
  public void toBeOrNotToBe() {
    GregorianCalendar cal = new GregorianCalendar();
    for(int i = 0; i<mainList.size(); i++)
      {
	MainElement me = (MainElement)mainList.get(i);
	
	int myLife = cal.HOUR_OF_DAY-me.getEndDate();
	if (myLife>life)
	  {
	    mainList.remove(i);
	  }
      }
  }
}
